#include"Heap.h"
#include"dijkstra.h"
#include <iostream>

#define MAX 100000

#define EPS 1e-1
#define UNLIMITED 1e+14


using namespace std;


// q[v_CNXg
void dijkstra(int start, vector<int> end, map<int,Node<Link>>& nodes, vector<int>& traf,map<int, Link>& links) {

	//m[hidm[hRXg擾q[v쐬
	Heap<double> heap(nodes.size());
	
	//
	for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
		i->second.isDetermined = false;
		i->second.minCost = UNLIMITED;
		i->second.PreLink = -1;
		heap.push(i->first, i->second.minCost);
	}
	
	
	nodes[start].minCost = 0.0;
	heap.modifyCost(start,0.0);

	//q[vɃm[hRXgi[
	//for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
	//	heap.push(i->first,i->second.minCost);
	//}
	//ŒZoHvZ
	while (1) {
		//݃m[h
		int doneNode = -1;
		//ŏpm[hid擾
		doneNode=heap.pop();
		//pm肷
		nodes[doneNode].isDetermined = true;
		//STĂΏI
		if (heap.isEmpty()) break;


		// mm[hs̃m[h̔pvZ
		for (unsigned int i = 0; i<nodes[doneNode].toNode.size(); i++) {
			int toNode = nodes[doneNode].toNode[i];
			/*cout <<doneNode<<","<< nodes[doneNode].toNode.size()<<","<<nodes[doneNode].links.size() << endl;
			cout << i << endl;*/
			//pvZ
			//cerr << "O"<<nodes[doneNode].links[i].cost << endl;
			double newCost=heap.getCost(doneNode)+nodes[doneNode].links[i].cost;
			//cerr << "NRXg" << nodes[doneNode].links[i].cost << "," << endl;
			if (nodes[toNode].isDetermined == false || newCost < nodes[toNode].minCost) {
				//pɍXV
				nodes[toNode].minCost = newCost;
				//q[ṽRXgpɏC
				heap.modifyCost(nodes[toNode].id,newCost);
				//sm[h|C^ݒ肷
				nodes[toNode].fromNode = doneNode;
				//sN|C^ݒ肷
				nodes[toNode].PreLink = nodes[doneNode].links[i].id;
				
			};
		}
		//delete &heap;
	}
	int index = 0;
	
	// s|C^ǂ
	for (vector<int>::iterator it = end.begin(); it != end.end(); it++)
	{
		
		int cur = *it;
#ifdef DEBUG
		cerr << "ŒZoHtɂǂĂ܂c" << endl;
#endif
		cout << start << "," << *it << endl;
		while (cur != start) {
//#ifdef DEBUG
			cerr << cur << " ";
//#endif
			
			int prev = nodes[cur].fromNode;
			//cout << "AAAAAAAAAAAAAAA" << endl;
			//cout << "TTTTT"<<nodes[cur].fromNode << endl;

			// ǂ̃ÑXg`FbNCǂւ̃NT
			bool isFound = false;
			//cout <<"" <<nodes[prev].toNode.size();
			for (unsigned int i = 0; i<nodes[prev].toNode.size(); i++) {
				
				if (nodes[prev].toNode[i] == cur) {
					//cout << start << "," << *it << ",";
					//cout << "TRAF:"<<traf[index] <<"INDEX:"<<index <<endl;
					nodes[prev].links[i].y += traf[index];
					
					isFound = true;
					break;
				}
			}
			if (!isFound) {
				cerr << "m[h܂" << endl;
				int hoge;
				cin >> hoge;
				exit(1);
			}
			cur = prev;
		}
		index++;
#ifdef DEBUG
		cerr << cur << endl;
#endif
	}


}

//
void dijkstra(int start, int end, map<int, Node<Link>>& nodes, double traf, map<int, Link>& links) {
#ifdef DEBUG
	cerr << "_CNXg@" << endl;
#endif
	//m[hidm[hRXg擾q[v쐬
	Heap<double> heap(nodes.size());
	//
	for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
		i->second.isDetermined = false;
		i->second.minCost = UNLIMITED;
		i->second.PreLink = -1;
		heap.push(i->first, i->second.minCost);
	}
	nodes[start].minCost = 0.0;
	heap.modifyCost(start, 0.0);
	//q[vɃm[hRXgi[
	//for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
	//	heap.push(i->first,i->second.minCost);
	//}
	int count = NULL;
	//ŒZoHvZ
	while (1) {
		//݃m[h
		int doneNode = -1;
		//ŏpm[hid擾
		doneNode = heap.pop();
		cerr << doneNode << ",";
		//pm肷
		nodes[doneNode].isDetermined = true;
		if (count == 10) {
			//break;
		}
		count++;
		//STĂΏI
		if (heap.isEmpty()) break;


		// mm[hs̃m[h̔pvZ
		for (unsigned int i = 0; i<nodes[doneNode].toNode.size(); i++) {
			int toNode = nodes[doneNode].toNode[i];
			//pvZ
			double newCost = heap.getCost(doneNode) + nodes[doneNode].links[i].cost;
			if (nodes[toNode].isDetermined ==false || newCost < nodes[toNode].minCost) {
				//pɍXV
				nodes[toNode].minCost = newCost;
				//q[ṽRXgpɏC
				heap.modifyCost(nodes[toNode].id, newCost);
				//sm[h|C^ݒ肷
				nodes[toNode].fromNode = doneNode;
				//sN|C^ݒ肷
				nodes[toNode].PreLink = nodes[doneNode].links[i].id;
			};
		}
	}

//
//	for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
//		i->second.isDetermined = false;
//		i->second.isInf = true;
//		i->second.minCost = 0.0;
//		i->second.PreLink = -1;
//	}
//	nodes[start].minCost = 0.0;
//	nodes[start].isInf = false;
//	cout << start << "," << end << endl;
//	while (1) {
//		//		cout << "nodes.size=" << nodes.size() << endl;
//		int doneNode = -1;
//
//		for (map<int, Node<Link>>::iterator i = nodes.begin(); i != nodes.end(); i++) {
//			if (i->second.isDetermined) {
//				//				cerr << i->first << " is determined\n";
//
//			}
//			else if (i->second.isInf) {
//				//				cerr << i->first << " is \n";
//
//			}
//			else if (doneNode == -1) {
//				doneNode = i->first;
//				//				cerr << "doneNode=-1 =>" << doneNode << endl;
//
//			}
//			else if (i->second.minCost < nodes[doneNode].minCost) {
//				doneNode = i->first;
//				//				cerr << "doneNode=" << doneNode << endl;
//
//			}
//		}
//
//		/*if (doneNode == -1) break;*/
//
//		nodes[doneNode].isDetermined = true;
//		//if (nodes[end].isDetermined == true) break;
//#ifdef DEBUG
//		cerr << "m[h " << doneNode << " ̃RXg " << nodes[doneNode].minCost << "Ɋm肵܂" << endl;
//#endif
//		// m[hRXg̍XV
//
//		for (unsigned int i = 0; i<nodes[doneNode].toNode.size(); i++) {
//			int toNode = nodes[doneNode].toNode[i];
//			//Hf
//			int judge = 1;
//			if (nodes[doneNode].links[i].ismotorway == 1)
//			{
//
//				judge = 2;
//				if (links[nodes[doneNode].PreLink].ismotorway == 1)
//				{
//
//					judge = 3;
//				}
//			}
//
//			double cost;
//			//ǉiq[vłɕύXKvj
//			cost = nodes[doneNode].minCost + nodes[doneNode].links[i].cost;
//			//if (judge == 1)
//			//{
//			//	
//			//	cost = nodes[doneNode].minCost + nodes[doneNode].links[i].tt1();
//			//}
//			//if (judge == 2)
//			//{
//			//	
//			//	cost = nodes[doneNode].minCost + nodes[doneNode].links[i].tt2();
//			//}
//			//if (judge == 3)
//			//{
//			//	
//			//	cost = nodes[doneNode].minCost + nodes[doneNode].links[i].tt3();
//			//}
//
//			if (nodes[toNode].isInf || cost < nodes[toNode].minCost) {
//				nodes[toNode].minCost = cost;
//				nodes[toNode].isInf = false;
//				nodes[toNode].fromNode = doneNode;
//				nodes[toNode].PreLink = nodes[doneNode].links[i].id;
//
//			}
//		}
//	}

	// s|C^ǂ
	int cur = end;
#ifdef DEBUG
	cerr << "ŒZoHtɂǂĂ܂c" << endl;
#endif
	cout << start << "," << end << endl;
	while (cur != start) {
#ifdef DEBUG
		cerr << cur << " ";
#endif
		int prev = nodes[cur].fromNode;
		cout << "AAAAAAAAAAAAAAA:" <<cur<< endl;
		cout << "TTTT:" << nodes[cur].fromNode << endl;

		// ǂ̃ÑXg`FbNCǂւ̃NT
		bool isFound = false;
		for (unsigned int i = 0; i<nodes[prev].toNode.size(); i++) {
			if (nodes[prev].toNode[i] == cur) {
				nodes[prev].links[i].y += traf;
				isFound = true;
				break;
			}
		}
		if (!isFound) {
			cerr << "m[h܂" << endl;
			int hoge;
			cin >> hoge;
			exit(1);
		}
		cur = prev;
	}
#ifdef DEBUG
	cerr << cur << endl;
#endif
}
