#pragma once
#include <map>
#include "Node.h"
#include "Link.h"

using namespace std;

extern inline void addLink(int& renban,map<int, Node<Link>>& nodes, map<int, Link>& links, int from, int to, int linkId, double ba, double ftime, double Capacity, double Length, double Power, int isMotorway,double Motorway, map<int, int>& renumberlist);

extern inline void clearY(map<int, Node<Link>>& nodes);

extern inline void updateX(map<int, Node<Link>>& nodes, double al);

extern inline void dijkstra(int start, int end, map<int, Node<Link>>& nodes, double traf, map<int, Link>& links);

extern inline void dijkstra(int start, vector<int> destinations, map<int, Node<Link>>& nodes, vector<double> trafs, map<int, Link>& links);

extern inline double obj(double al, map<int, Node<Link>> nodes, map<int, Link>& links);

extern inline double gold(map<int, Node<Link>>& nodes, map<int, Link>& links);

extern inline void printLinkData(map<int, Node<Link>>& nodes, map<int, Link>& links);

extern inline double convergence(map<int, Node<Link>>& nodes, double al, double linknum);
